$regfile = "attiny13a.dat"
$crystal = 1000000
$hwstack = 32
$swstack = 8
$framesize = 16

On Int0 Powon
Config Int0 = Low Level
Enable Int0

Set Acsr.acd
Reset Acsr.acbg

Config Portb.2 = Input                                      'switch
Config Portb.1 = Output                                     'led
Config Portb.0 = Output                                     'Buzzer

Config Timer0 = Timer , Prescale = 1024

Config Adc = Single , Prescaler = Auto , Reference = Internal

Dim U As Byte
Dim S As Integer
Dim X As Byte

Do
Disable Interrupts
U = 1
S = 120 * U
X = 1
Osnstart:
Portb.1 = 0
Stop Timer0
Timer0 = 0
X = 1
Wait 2
Start Adc

Osn:
If Pinb.2 = 0 Then Goto Knopka
If Getadc(1) > S Then Goto Beepled
If Timer0 > 254 Then
X = X + 1
End If
If X > 40 Then
X = 1
Stop Timer0
Timer0 = 0
Portb.1 = 0
End If
Goto Osn

Beepled:
If Getadc(2) > 1000 Then Goto Powoff
X = 1
Stop Timer0
Timer0 = 0
Portb.1 = 0
Start Timer0
Sound Portb.0 , 1 , 50000
Portb.1 = 1
Goto Osn

Knopka:
Stop Adc
Portb.1 = 0
Stop Timer0
Timer0 = 0
Sound Portb.0 , 3 , 50000
Wait 2
If Pinb.2 = 1 Then Goto Powoff
If Pinb.2 = 0 Then Goto Pruch

Pruch:
Portb.1 = 1
Sound Portb.0 , U , 50000
Wait 3
While Pinb.2 = 0
Sound Portb.0 , U , 50000
Wait 2
If Pinb.2 = 1 Then Goto Pruchk
U = U + 1
If U = 7 Then U = 1
Wend
Pruchk:
S = 120 * U
Goto Osnstart

Powoff:
X = 1
Stop Timer0
Timer0 = 0
Portb.1 = 0
Stop Adc
Portb.0 = 1
Wait 2
Portb.0 = 0
Enable Interrupts
Goto Pdn

Pdn:
Powerdown
Disable Interrupts
Portb.0 = 1
Wait 2
Portb.0 = 0
Goto Osnstart

Loop

Powon:
Waitms 100
While Pinb.2 = 0
Wend
Return

End